﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace Experiments
{
    class Program
    {
        private static Dictionary<string, Dictionary<int, double>> listOfVectorsForQuery = new Dictionary<string, Dictionary<int, double>>();
        private static Dictionary<int, double> sumActivityVector = new Dictionary<int, double>();
        private static Dictionary<int, double> CreateVectorByDayOfWeekVSHour(string queryId)
        {
            Dictionary<int, double> vector = new Dictionary<int, double>();
            //List<double> vectorOfQuery = new List<double>(7);
            StreamReader inputData = new StreamReader("inputData.txt");

            string currentLine = String.Empty;
            int numberOfSemocolon = 0;
            int currentSymbol = 0;

            DateTime currentDate = new DateTime();
            string currentDateString = String.Empty;
            string currentHour = String.Empty;
            string currentTymeOfExecution = String.Empty;

            while ((currentLine = inputData.ReadLine()) != null)
            {
                while (currentSymbol < queryId.Length && currentLine[currentSymbol] == queryId[currentSymbol])
                {
                    currentSymbol++;
                }
                if (currentSymbol == queryId.Length)
                {
                    currentSymbol++;
                    if (currentLine[currentSymbol] == '.')
                    {
                        currentTymeOfExecution += '0';
                    }
                    while (currentLine[currentSymbol] != ';')
                    {
                        if (currentLine[currentSymbol] == '.')
                        {
                            currentTymeOfExecution += ',';
                        }
                        else
                        {
                            currentTymeOfExecution += currentLine[currentSymbol];
                        }
                        currentSymbol++;
                    }

                    while (numberOfSemocolon != 3)
                    {
                        if (currentLine[currentSymbol] == ';')
                        {
                            numberOfSemocolon++;
                        }
                        currentSymbol++;
                    }
                    while (currentLine[currentSymbol] != ';')
                    {

                        currentDateString += currentLine[currentSymbol];

                        currentSymbol++;
                    }

                    currentDateString += " ";
                    currentSymbol++;
                    currentHour += currentLine[currentSymbol];
                    currentHour += currentLine[currentSymbol + 1];
                    while (currentLine[currentSymbol] != ',')
                    {
                        currentDateString += currentLine[currentSymbol];

                        currentSymbol++;
                    }
                    DateTime.TryParse(currentDateString, out currentDate);
                    if (!vector.ContainsKey(currentDate.DayOfYear))
                    {
                        vector.Add(currentDate.DayOfYear, Convert.ToDouble(currentTymeOfExecution));
                    }
                    else
                    {
                        vector[currentDate.DayOfYear]+=Convert.ToDouble(currentTymeOfExecution);
                    }
                    numberOfSemocolon = 0;
                    currentSymbol = 0;
                    currentTymeOfExecution = String.Empty;
                    currentDateString = string.Empty;
                    currentHour = string.Empty;
                }
                currentSymbol = 0;
            }
            return vector;
        }
        static void Main(string[] args)
        {
            string values = string.Empty;
            string currentLine = String.Empty;
            int currentSymbol = 0;
            string queryId = String.Empty;
            StreamReader inputDataOp = new StreamReader("inputData.txt");

            while ((currentLine = inputDataOp.ReadLine()) != null)
            {
                while (currentLine[currentSymbol] != ';')
                {
                    queryId += currentLine[currentSymbol];
                    currentSymbol++;
                }
                if (!listOfVectorsForQuery.ContainsKey(queryId))
                {
                    listOfVectorsForQuery.Add(queryId, CreateVectorByDayOfWeekVSHour(queryId));
                }
                queryId = string.Empty;
                currentSymbol = 0;
            }
            foreach (KeyValuePair<string, Dictionary<int, double>> pair in listOfVectorsForQuery)
            {
                foreach(KeyValuePair<int,double> dayActivity in pair.Value)
                {
                    if (!sumActivityVector.ContainsKey(dayActivity.Key))
                    {
                        sumActivityVector.Add(dayActivity.Key, dayActivity.Value);
                    }
                    else
                    {
                        sumActivityVector[dayActivity.Key] += dayActivity.Value;
                    }
                }
            }
            StreamWriter output = new StreamWriter("output.txt");
            StreamWriter output2 = new StreamWriter("output2.txt");

            foreach(KeyValuePair<int,double> dayActivity in sumActivityVector)
            {
                if (dayActivity.Value > 200000)
                {
                    output2.WriteLine(dayActivity.Key);
                }
                output.WriteLine(dayActivity.Key + " " + dayActivity.Value);
            }
            output2.Close();
            output.Close();
            Console.Write(" ");
        }
    }
}
